package xptoolkit.cactus;

import javax.servlet.http.*;
import java.util.*;
import java.io.*;

/**
 * $Revision: 1.2 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/17 16:14:30 $.
 * Modified version of example application from "Java Tools for Extreme Programming" by Hightower/Lesiecki.
 * Demo application for exercising Cactus tests and HttpUnit response.
 * Maps parameters to session and returns HTML page containing parameters (name/value) in a table. 
 */
public class MapperServlet extends HttpServlet {

    /**
     * Generate HTML file with table containing request parameters and values
     */
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException {
        Map paramMap = SessionMapper.mapRequestToSession(request);
        response.setContentType("text/html");
        PrintWriter writer = response.getWriter();
        Set mapEntries = paramMap.entrySet();
        Map.Entry e = null;

        writer.println("<html><body><table border='1'>");
        for (Iterator it = mapEntries.iterator(); it.hasNext(); ) {
            Map.Entry entry = (Map.Entry)it.next();
            String key = (String)entry.getKey();
            String value = (String)entry.getValue();

            if (useAllCaps()) {
                key = key.toUpperCase();
                value = value.toUpperCase();
            }

            String entryStr = "<tr><td><b>" + key + "</b></td><td>" + value + "</td></tr>";

            writer.println(entryStr);
        }
        writer.println("</table></body></html>");
    }

    /**
     * Get init parameter ALL_CAPS
     */
    public boolean useAllCaps() {
        String useAllCapsStr = getServletConfig().getInitParameter("ALL_CAPS");
        return useAllCapsStr.equalsIgnoreCase("true");
    }
}

