package xptoolkit.cactus;

import org.apache.cactus.*;
import junit.framework.*;
import java.util.Map;

/**
 * $Revision: 1.2 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/17 16:14:31 $.
 * Modified version of example application from "Java Tools for Extreme Programming" by Hightower/Lesiecki.
 * Test case for exercising Cactus tests. 
 */
public class SessionMapperTest extends ServletTestCase {
    
    public SessionMapperTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(SessionMapperTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    /**
     * This runs on the client-side. Don't define any server-side variables
     * in this method (they will be null on the server).
     */
    public void beginSessionMapper(WebRequest clientSideRequest) { // name of class
        clientSideRequest.addParameter("pet", "Bandersnatch");
    }
    
    /**
     * This runs on the server-side */
    public void testSessionMapper() {
        Map map = SessionMapper.mapRequestToSession(request);
        String value = (String) session.getAttribute("pet"); // get from session object
        assertEquals("Bandersnatch", value);
        value = (String)map.get("pet"); // get from session mapper
        assertEquals("Bandersnatch", value);
    }
}
