package xpbook;

import java.io.*;
import javax.servlet.jsp.*;
import javax.servlet.http.*;
import javax.servlet.jsp.tagext.*;

public class ParentTag extends BodyTagSupport {
    
    public boolean containsChildren;
    private String name;
    
    public void setName(String name) {
        this.name = name;
    }
    
    public void setContainsChildren(boolean containsChildren) {
        this.containsChildren = containsChildren;
    }
    
    public String getName() {
        return name;
    }
    
    public boolean getContainsChildren() {
        return containsChildren;
    }
    
    public int doStartTag() {
        return EVAL_BODY_INCLUDE;
    }
    
    public int doAfterBody() throws JspException {
        JspWriter out = pageContext.getOut();
        try {
            out.print("<p>Parent tag " + name + " does ");
            if (!containsChildren) {
                out.print("not");
            }
            out.println("contain children.");
        } catch (IOException e) {
            throw new JspTagException("" + e);
        }
        return SKIP_BODY;
    }
}
