package xpbook;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

import org.apache.cactus.*;
import junit.framework.*;

/**
 * $Revision: 1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/28 20:28:05 $.
 * Implementation of example application from "Java Tools for Extreme Programming" by Hightower/Lesiecki.
 * Test case for exercising Cactus tests and simple Cactus WebResponse response. 
 */
public class ParentTagTest extends JspTestCase {
    
    public ParentTagTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(ParentTagTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    private ParentTag tag;
    private BodyContent tempOut;
    
    public void setUp() {
        tag = new ParentTag();
        tag.setPageContext(pageContext);
        tag.setName("testName");
        tempOut = pageContext.pushBody();
    }
    
    /**
     * Tests doAfterBody
     */
    public void testNoChildren() throws JspException {
        tag.setContainsChildren(false);
        tag.doAfterBody();
        String result = tempOut.getString();
        assertTrue(result.indexOf("not") > -1);
    }
    
    /**
     * Tests doAfterBody
     */
    public void testChildren() throws JspException {
        tag.setContainsChildren(true);
        tag.doAfterBody();
        String result = tempOut.getString();
        assertTrue(result.indexOf("not") == -1);
    }
}
