package xpbook;

import java.io.*;
import javax.servlet.jsp.*;
import javax.servlet.http.*;
import javax.servlet.jsp.tagext.*;

public class RepeatTag extends BodyTagSupport {
    
    private int repetitions;
    private int count;
    
    public void setRepetitions(String repetitions) {
        this.repetitions = Integer.parseInt(repetitions);
    }
    
    public void doInitBody() {
        count = 0;
    }
    
    public int doStartTag() {
        if (repetitions > 0) {
            return EVAL_BODY_INCLUDE;
        }
        return SKIP_BODY;
    }
    
    public int doAfterBody() {
        if(++count < repetitions) {
            return EVAL_BODY_AGAIN;
        }
        return SKIP_BODY;
    }
}
