package xpbook;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

import org.apache.cactus.*;
import junit.framework.*;

/**
 * $Revision: 1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/28 20:28:06 $.
 * Implementation of example application from "Java Tools for Extreme Programming" by Hightower/Lesiecki.
 * Test case for exercising Cactus tests and simple Cactus WebResponse response. 
 */
public class RepeatTagTest extends JspTestCase {
    
    public RepeatTagTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(RepeatTagTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    private RepeatTag tag;
    
    public void setUp() {
        tag = new RepeatTag();
        tag.setPageContext(this.pageContext);
    }
    
    public void testDoStartTag() {
        tag.setRepetitions("0");
        assertEquals(TagSupport.SKIP_BODY, tag.doStartTag());
        
        tag.setRepetitions("2");
        assertEquals(TagSupport.EVAL_BODY_INCLUDE, tag.doStartTag());
    }
    
    public void testDoAfterBody() throws java.io.IOException {
        tag.setRepetitions("6");
        int count = 0;
        do {
            count++;
            out.print("Line " + count + "<br>\n");
        } while (tag.doAfterBody() == BodyTagSupport.EVAL_BODY_AGAIN);
        
        assertEquals(6, count);  // on third time, tag.doAfterBody() will return SKIP_BODY
    }
}
