package xpbook;

import java.io.IOException;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.util.Hashtable;

import org.apache.cactus.*;
import junit.framework.*;

/**
 * $Revision: 1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/28 20:28:06 $.
 * Implementation of example application from "Java Tools for Extreme Programming" by Hightower/Lesiecki.
 * Test case for exercising Cactus tests and simple Cactus WebResponse response. 
 */
public class VarTEITest extends JspTestCase {
    
    public VarTEITest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(VarTEITest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    private VarTEI tag;
    private String fakeVariable = "fakeVariable";
    private TagData data;
    
    public void setUp() {
        tag = new VarTEI();
        Hashtable table = new Hashtable();
        table.put("name", fakeVariable);
        data = new TagData(table);
    }
    
    public void testGetVariableInfo(TagData data) {
        VariableInfo[] info = tag.getVariableInfo(data);
        assertEquals(1, info.length);
        assertEquals(fakeVariable, info[0]);
    }
    
    public void testIsValid() {
        assertTrue(tag.isValid(data));
    }
    
}
