package xpbook;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

import org.apache.cactus.*;
import junit.framework.*;

/**
 * $Revision: 1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/28 20:28:06 $.
 * Implementation of example application from "Java Tools for Extreme Programming" by Hightower/Lesiecki.
 * Test case for exercising Cactus tests and simple Cactus WebResponse response. 
 */
public class VarTagTest extends JspTestCase {
    
    public VarTagTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(VarTagTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    private VarTag tag;
    
    public void setUp() {
        tag = new VarTag();
        tag.setPageContext(this.pageContext);
        tag.setName("moo");
        tag.setValue("voo cah");
    }
    
    public void testDoStartTag() throws JspException {
        int action = tag.doStartTag();
        assertEquals(action, TagSupport.SKIP_BODY);
        
        String variable = (String)pageContext.getAttribute("moo");
        
        assertNotNull(variable);
        assertEquals(variable, "voo cah");
    }
    
    /**
     * This test runs a JSP page which has additional assertions.
     * The page must be deployed with the rest of the test pack.
     * This test will only be useful if the container always uses a fresh copy.
     * There is NO GUARANTEE that the container will not use an
     * older JSP translation. With Tomcat 4 (Win), it works OK.
     */
    public void testVarCreate() throws javax.servlet.ServletException, java.io.IOException {
        pageContext.include("/varCreateTest.jsp");
    }
}
