package hello.rmi.client;

import hello.rmi.RemoteHello;
import java.rmi.*;

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;

/**
 * Esta classe  uma aplicaao cliente que consulta o RMIRegistry
 * usando o nome do objeto e espera receber o objeto. O objeto 
 * convertido em RemoteHello e seus mtodos so chamados.
 */
public class HelloClient extends JFrame {
    
    private JTextArea  area;
    private JTextField texto, host;
    private JButton bEnviar;
    
    private String objetoRemoto;
    
    public HelloClient(String objetoRemoto) {
        super("Cliente remoto para objeto: '"+objetoRemoto+"'");
        
        this.objetoRemoto = objetoRemoto;
        
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        area = new JTextArea();
        JScrollPane pane = new JScrollPane(area);
        getContentPane().add(pane);
        
        host = new JTextField("localhost");
        JPanel hostPanel = new JPanel(new BorderLayout());
        hostPanel.add(BorderLayout.WEST, new JLabel("Hostname"));
        hostPanel.add(host);
        
        texto = new JTextField();
        JPanel textoPanel = new JPanel(new BorderLayout());
        textoPanel.add(BorderLayout.WEST, new JLabel("Mensagem"));
        textoPanel.add(texto);
        
        bEnviar = new JButton("Enviar Mensagem");
        bEnviar.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                enviarReceber(texto.getText(), host.getText());
            }
        });
        textoPanel.add(BorderLayout.EAST, bEnviar);
        
        JPanel topPanel = new JPanel(new GridLayout(2, 1));
        topPanel.add(hostPanel);
        topPanel.add(textoPanel);
        
        getContentPane().add(BorderLayout.NORTH, topPanel);
        
        setSize(500,400);
        setVisible(true);

    }
    
    public void enviarReceber(String mensagem, String hostname) {
        try {
            Object obj = java.rmi.Naming.lookup("rmi://" + hostname + "/" + objetoRemoto);
            RemoteHello hello = (RemoteHello) obj;
        
            area.setText(area.getText() + "Mensagem recebida: " + hello.getMensagem() + "\n");
            hello.setMensagem("[" + java.net.InetAddress.getLocalHost() + "] " + mensagem);
        } catch (NotBoundException e) {
            area.setText(area.getText() + "Erro: No existe objeto com o nome '" + objetoRemoto + "' no servidor.\n");
        } catch (RemoteException e) {
            area.setText(area.getText() + "Erro de comunicao com o servidor: " + e + "\n");
        } catch (java.net.MalformedURLException e) {
            area.setText(area.getText() + "Erro: Sintaxe incorreta para URL rmi:// " + hostname + "/" + objetoRemoto + "\n");
        } catch (java.net.UnknownHostException e) { /* Local Host */ }
    }
    
    public static void main(String[] args) throws Exception {
        new HelloClient("mensagens");
    }
}
