package junitdemo;

import junit.framework.*;

/**
 * Test case para Tiracentos. Tambm funciona com Tiracentos2 (verso I18n).
 * $Revision: 1.1.1.1 $ $Date: 2002/02/17 23:07:34 $
 * Requer JUnit Framework (www.junit.org)
 */
public class TiracentosTest extends TestCase {

    private static final String ASCII_ALPHABET = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
    private static final String NUMBERS = "0123456789";
    private static final String SYMBOLS_ASCII_KEYBOARD = " !\"#$%&'()*+,-./:;<=>?@[\\]^_`{|}~";
    
    private static final String CHARS_ACCENTED_ORIGINAL = "";
    private static final String CHARS_ACCENTED_MODIFIED = "AAAAAAECEEEEIIIIDNOOOOOOUUUUYPBaaaaaaeceeeeiiiidnoooooouuuuypy";
    
    private static final String SYMBOLS_EXTENDED_ORIGINAL = "";
    private static final String SYMBOLS_EXTENDED_MODIFIED = " !cLoY|S:Ca<--R-o~23\'uP.,1o>123?x/";
    
    public TiracentosTest (String nome) {
        super(nome);
    }
    
    public void testToAscii() {
        String alphabet = Tiracentos.toAscii(ASCII_ALPHABET);  
        String numeros  = Tiracentos.toAscii(NUMBERS);   
        String symbols  = Tiracentos.toAscii(SYMBOLS_ASCII_KEYBOARD);   
        assertEquals(alphabet, ASCII_ALPHABET);
        assertEquals(numeros, NUMBERS);
        assertEquals(symbols, SYMBOLS_ASCII_KEYBOARD);
        
        String accented = Tiracentos.toAscii(CHARS_ACCENTED_ORIGINAL);
        assertEquals(CHARS_ACCENTED_MODIFIED, accented);
        
        String modified = Tiracentos.toAscii(SYMBOLS_EXTENDED_ORIGINAL);
        assertEquals(SYMBOLS_EXTENDED_MODIFIED, modified);
    }
    
    public static Test suite() {
        return new TestSuite(TiracentosTest.class);
    }
    
    public static void main (String[] args) {
        junit.textui.TestRunner.run ( suite() );
    }

}
