package br.javali.editor.io;

import java.io.IOException;

/** Abstrao de um meio persistente de armazenamento */
public interface Persistencia {
    
    /**
     * Implementao da interface Persistencia.
     * L um arquivo do meio persistente que implementar esta interface.
     * @param localizador Localizador (url, arquivo) do recurso que ser lido.
     * @return Texto contido no arquivo
     */
    public String load(String localizador) throws IOException;
    
    /**
     * Implementao da interface Persistencia.
     * Grava um arquivo no meio persistente que implementar esta interface.
     * @param texto Texto a ser gravado.
     * @param localizador Localizador do recurso que receber o texto.
     */
    public void save(String texto, String localizador) throws IOException;
    
}
