package strutsdemo.tests;

import org.apache.cactus.*;
import javax.servlet.jsp.JspException;
import junit.framework.*;
import org.apache.struts.taglib.logic.EqualTag;

/**
 * $Revision: 1.1.1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/27 18:04:43 $.
 * TestCase to exercise the Struts equals JSP custom tag
 */
public class EqualTest extends JspTestCase {
    
    public EqualTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(EqualTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    EqualTag trueTag, falseTag;
    
    public void beginEquals(WebRequest webRequest) { 
        webRequest.addParameter("number", "7");
    }
    
    public void beginNotEquals(WebRequest webRequest) { 
        webRequest.addParameter("number", "999");
    }
    
    public void setUp() {
        trueTag = new EqualTag();
        trueTag.setPageContext(this.pageContext); // this is essential
        trueTag.setParameter("number");
        trueTag.setValue("7");
    }

    public void testEquals() throws JspException {
        // This is dependent on the internal workings of the JSP architecture and Struts model of implementation
        assertEquals(trueTag.EVAL_BODY_INCLUDE, trueTag.doStartTag()); // it will eval body
    }
    
    public void testNotEquals() throws JspException {
        // This is dependent on the internal workings of the JSP architecture and Struts model of implementation
        assertEquals(trueTag.SKIP_BODY, trueTag.doStartTag()); // it will skip body
    }
}
