package strutsdemo.tests;

import org.apache.cactus.*;
import javax.servlet.jsp.JspException;
import junit.framework.*;
import org.apache.struts.taglib.logic.GreaterThanTag;

/**
 * $Revision: 1.1.1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/27 18:04:43 $.
 * TestCase to exercise the Struts equals JSP custom tag
 */
public class GreaterThanTest extends JspTestCase {
    
    public GreaterThanTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(GreaterThanTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    GreaterThanTag tag;
    
    public void beginLessThan(WebRequest webRequest) { 
        webRequest.addParameter("number", "0");
    }
    
    public void beginEquals(WebRequest webRequest) { 
        webRequest.addParameter("number", "7");
    }
    
    public void beginGreaterThan(WebRequest webRequest) { 
        webRequest.addParameter("number", "999");
    }
    
    public void setUp() {
        tag = new GreaterThanTag();
        tag.setPageContext(this.pageContext); // this is essential
        tag.setParameter("number");
        tag.setValue("7");
    }

    public void testGreaterThan() throws JspException {
        assertEquals(tag.EVAL_BODY_INCLUDE, tag.doStartTag()); // it will eval body
    }
    
    public void testEquals() throws JspException {
        assertEquals(tag.SKIP_BODY, tag.doStartTag()); // it will skip body
    }
    
    public void testLessThan() throws JspException {
        assertEquals(tag.SKIP_BODY, tag.doStartTag()); // it will skip body
    }
}
