package strutsdemo.tests;

import org.apache.cactus.*;
import javax.servlet.jsp.JspException;
import junit.framework.*;
import org.apache.struts.taglib.logic.NotEqualTag;

/**
 * $Revision: 1.1.1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/27 18:04:43 $.
 * TestCase to exercise the Struts equals JSP custom tag
 */
public class NotEqualTest extends JspTestCase {
    
    public NotEqualTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(NotEqualTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    NotEqualTag falseTag;
    
    public void beginEquals(WebRequest webRequest) { 
        webRequest.addParameter("number", "7");
    }
    
    public void beginNotEquals(WebRequest webRequest) { 
        webRequest.addParameter("number", "999");
    }
    
    public void setUp() {
        falseTag = new NotEqualTag();
        falseTag.setPageContext(this.pageContext); // this is essential
        falseTag.setParameter("number");
        falseTag.setValue("7");
    }

    public void testNotEquals() throws JspException {
        // This is dependent on the internal workings of the JSP architecture and Struts model of implementation
        assertEquals(falseTag.EVAL_BODY_INCLUDE, falseTag.doStartTag()); // it will eval body
    }
    
    public void testEquals() throws JspException {
        // This is dependent on the internal workings of the JSP architecture and Struts model of implementation
        assertEquals(falseTag.SKIP_BODY, falseTag.doStartTag()); // it will skip body
    }
}
