package strutsdemo.tests;

import org.apache.cactus.*;
import javax.servlet.jsp.JspException;
import junit.framework.*;
import org.apache.struts.taglib.logic.NotPresentTag;

/**
 * $Revision: 1.1.1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/27 18:04:43 $.
 * TestCase to exercise the Struts equals JSP custom tag
 */
public class NotPresentTest extends JspTestCase {
    
    public NotPresentTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(NotPresentTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    NotPresentTag tag;
    
    public void beginNotPresent(WebRequest webRequest) { 
        // set nothing
    }
    
    public void beginPresent(WebRequest webRequest) { 
        webRequest.addParameter("number", "anything");
    }
    
    public void setUp() {
        tag = new NotPresentTag();
        tag.setPageContext(this.pageContext); // this is essential
        tag.setParameter("number");
    }

    public void testNotPresent() throws JspException {
        assertEquals(tag.EVAL_BODY_INCLUDE, tag.doStartTag()); // it will eval body
    }
    
    public void testPresent() throws JspException {
        assertEquals(tag.SKIP_BODY, tag.doStartTag()); // it will skip body
    }
}
