package strutsdemo.tests;

import org.apache.cactus.*;
import javax.servlet.jsp.JspException;
import junit.framework.*;
import org.apache.struts.taglib.bean.ParameterTag;

/**
 * $Revision: 1.1.1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/27 18:04:43 $.
 * TestCase to exercise the Struts equals JSP custom tag
 */
public class ParameterTest extends JspTestCase {
    
    public ParameterTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(ParameterTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    ParameterTag tag;
    int startAction, endAction;
    
    public void beginBeanIsSet(WebRequest webRequest) { 
        webRequest.addParameter("number", "135");
    }
    
    public void beginGetParameterValue(WebRequest webRequest) { 
        webRequest.addParameter("number", "135");
    }
    
    public void setUp() throws JspException {
        tag = new ParameterTag();
        tag.setPageContext(this.pageContext); // this is essential
        tag.setId("guess");
        tag.setName("number");
        startAction = tag.doStartTag(); // I'm ignoring these effects for these tests
        endAction = tag.doEndTag();
    }

    public void testBeanIsSet() throws JspException {
        Object bean = pageContext.getAttribute("guess");
        assertNotNull(bean);
    }
    
    public void testGetParameterValue() throws JspException {
        String paramValue = (java.lang.String)pageContext.findAttribute("guess");
        assertEquals("135", paramValue);
    }

}
