package strutsdemo.tests;

import org.apache.cactus.*;
import javax.servlet.jsp.JspException;
import junit.framework.*;
import org.apache.struts.taglib.bean.*;

/**
 * $Revision: 1.1.1.1 $. Helder da Rocha (helder@ibpinet.net). $Date: 2002/02/27 18:04:43 $.
 * TestCase to exercise the Struts equals JSP custom tag
 */
public class WriteTest extends JspTestCase {
    
    public WriteTest(String name) {
        super(name);
    }
    public static TestSuite suite() {
        return new TestSuite(WriteTest.class);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    ParameterTag beanTag;
    WriteTag tag;
    int startAction, endAction;
    
    public void beginWrite(WebRequest webRequest) { 
        webRequest.addParameter("number", "135");
    }
    
    public void setUp() throws JspException {
        beanTag = new ParameterTag();
        beanTag.setPageContext(this.pageContext); // this is essential
        beanTag.setId("guess");
        beanTag.setName("number");
        beanTag.doStartTag();
        beanTag.doEndTag();
        
        tag = new WriteTag();
        tag.setPageContext(this.pageContext);
        tag.setName("guess");
        startAction = tag.doStartTag(); // I'm ignoring these effects for these tests
        endAction = tag.doEndTag();
    }
    
    public void testWrite() {
        // I just want to know it the correct results were written (below)
    }

    public void endWrite(WebResponse webResponse) throws JspException {
        String respStr = webResponse.getText();
        boolean hasNumber = respStr.indexOf("135") != -1;
        assertTrue(hasNumber);
    }

}
