package taglibdemo;

import java.io.*;
import java.text.NumberFormat;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

/**
 * Simple tag. No attriutes. No body content
 */
public class DebugBufferTag extends TagSupport {
    
    public int doStartTag() throws JspException {
        JspWriter out = pageContext.getOut();
        
        int total = out.getBufferSize();
        int available = out.getRemaining();
        int used = total - available;
        
        try {
            out.print("Buffer Status: " + used + "/" + total + " = ");
            NumberFormat percentFmt = NumberFormat.getInstance();
            percentFmt.setMinimumFractionDigits(1);
            percentFmt.setMaximumFractionDigits(3);
            out.print(percentFmt.format( (100.0 * used) / total ) + "%");
        } catch (IOException e) {
            throw new JspTagException("" + e);
        }
        return SKIP_BODY;
    }
    
}
