package taglibdemo;

import java.io.*;
import javax.servlet.jsp.*;
import javax.servlet.http.*;
import javax.servlet.jsp.tagext.*;

/**
 * Simple tag. No attriutes. No body content
 */
public class DebugCookiesTag extends TagSupport {
    
    private String style = "text"; // default
    
    public void setStyle(String style) {
        this.style = style;
    }
    
    public String getStyle() {
        return style;
    }
    
    public int doStartTag() throws JspException {
        JspWriter out = pageContext.getOut();
        javax.servlet.ServletRequest request = pageContext.getRequest();
        
        if (request instanceof HttpServletRequest) {
            HttpServletRequest httpRequest = (HttpServletRequest) request;
            Cookie[] cookies = httpRequest.getCookies();
            int len = cookies.length;
            
            try {
                boolean doHTML = style.equalsIgnoreCase("HTML");
                if (doHTML) {
                    out.println("<ul>");
                }
                for (int i = 0; i < len; i++) {
                    Cookie cookie = cookies[i];
                    if (doHTML) out.println("<li><b>");
                    out.println(cookie.getName());
                    if (doHTML) out.println("</b>");
                    out.println(" = " + cookie.getName() + "\n");
                }
                if (doHTML) {
                    out.println("</ul>");
                }
            } catch (IOException e) {
                throw new JspTagException("" + e);
            }
        }
        return SKIP_BODY;
    }
    
    public void release() {
        super.release();
        style = "text";
    }
}
